// arrays of specially-named sections of the model tree 
var BBOARDobjsArray  = new Array(); // stores the billboard meshes 
var BBOARDposArray   = new Array(); // stores the billboard positions 
var BBOARDscaleArray = new Array(); // stores the billboard scales 
var BBOARDCount = 0;           // how many billboard meshes are there? 
var PrettyDrawingObjsArray      = new Array(); 
var PrettyDrawingPosArray       = new Array(); 
var PrettyDrawingTransformArray = new Array(); 
var PrettyDrawingCount = 0; 
 
// temporary variables 
var currMesh = null; 
var currname = ""; 
 
// compile lists of BBOARD*, VRSET* and FRAME* meshes 
for (i=0; i<scene.meshes.count; i++) {  
  currMesh = null; 
  currname = ""; 
  currMesh = scene.meshes.getByIndex(i);  
  currname = currMesh.name; 
 
  if ( currname.indexOf("Billboard") > -1 ) { 
    BBOARDobjsArray[BBOARDCount] = currMesh; 
    var bb_scale = Math.pow(Math.abs(currMesh.transform.determinant),1.0/3.0);	// scale. 
    var bb_center = currMesh.computeBoundingBox().center; 	// center (vector3) 
    BBOARDposArray[BBOARDCount] = currMesh.transform.translation.addScaled(bb_center, bb_scale); 	// center position (vector3) 
    BBOARDscaleArray[BBOARDCount] = Matrix4x4().translate(bb_center.scale(-1)).scale(bb_scale, bb_scale, bb_scale); 
    BBOARDCount++; 
  } 
  if ( currname.indexOf("LinePrettyDrawing") > -1 ) { 
    PrettyDrawingObjsArray[PrettyDrawingCount] = currMesh; 
    PrettyDrawingPosArray[PrettyDrawingCount] = currMesh.transform.translation.add(currMesh.computeBoundingBox().center); 	// center position (vector3) 
    PrettyDrawingTransformArray[PrettyDrawingCount] = Matrix4x4(currMesh.transform); 
    PrettyDrawingCount++; 
  } 
 
 } 
 
// Get Camera 
var camera = scene.cameras.getByIndex(0); 
 
function doBillboard() { 
	 
	// Loop through all billboards, orientating their view direction with the camera position. 
	var cam_posn = camera.position.subtract(camera.targetPosition);	// Camera's position vector (vector3) 
	var cam_up = camera.up.subtract(camera.position);		// Camera's up vector (vector3) 
	for (j = 0; j < BBOARDCount; j++) { 
		var bb_posn = BBOARDposArray[j]; 
		var bb_trans = Matrix4x4(); 
		bb_trans.setView(bb_posn, cam_posn.add(bb_posn), cam_up.add(bb_posn)); 
		BBOARDobjsArray[j].transform.set(BBOARDscaleArray[j].multiply(bb_trans));	// Set billboard view. 
	} 
 
} 
 
function doPrettyDrawing() { 
	 
	// Loop through all PrettyDrawings shifting them slighly towards the camera position. 
	var cam_posn = camera.position;	// Camera's position vector (vector3) 
	for (j = 0; j < PrettyDrawingCount; j++) { 
		var bb_posn = PrettyDrawingPosArray[j]; 
		PrettyDrawingObjsArray[j].transform.set(PrettyDrawingTransformArray[j].translate(camera.position.subtract(PrettyDrawingPosArray[j]).scale(0.0001))); 
	} 
 
} 
 
mreh = new MouseEventHandler(); 
mreh.onMouseDown = false; 
mreh.onMouseMove = true; 
mreh.reportAllTargets = false; 
mreh.onEvent = function(event) { 
  if (event.leftButtonDown) { 
    doBillboard(); 
    doPrettyDrawing(); 
  } 
} 
runtime.addEventHandler(mreh); 
 
ceh = new RenderEventHandler(); 
ceh.onEvent = function(event) { 
  doBillboard(); 
  doPrettyDrawing(); 
} 
runtime.addEventHandler(ceh); 
 
doBillboard(); 
doPrettyDrawing(); 
